/// <reference types="react" />
import { Moment } from 'moment';
import { PickerProps, PickerDateProps, RangePickerProps as BaseRangePickerProps } from './generatePicker';
export declare type DatePickerProps = PickerProps<Moment>;
export declare type MonthPickerProps = Omit<PickerDateProps<Moment>, 'picker'>;
export declare type WeekPickerProps = Omit<PickerDateProps<Moment>, 'picker'>;
export declare type RangePickerProps = BaseRangePickerProps<Moment>;
declare const DatePicker: import("react").ComponentClass<PickerProps<Moment>, any> & {
    WeekPicker: import("react").ComponentClass<Pick<Pick<import("rc-picker/lib/Picker").PickerDateProps<Moment>, "value" | "style" | "direction" | "className" | "prefixCls" | "getPopupContainer" | "onChange" | "disabled" | "onClick" | "open" | "suffixIcon" | "clearIcon" | "mode" | "defaultValue" | "allowClear" | "defaultOpen" | "dropdownClassName" | "dropdownAlign" | "transitionName" | "autoFocus" | "placeholder" | "tabIndex" | "onSelect" | "onBlur" | "onFocus" | "onMouseDown" | "onMouseEnter" | "onMouseLeave" | "aria-activedescendant" | "aria-atomic" | "aria-autocomplete" | "aria-busy" | "aria-checked" | "aria-colcount" | "aria-colindex" | "aria-colspan" | "aria-controls" | "aria-current" | "aria-describedby" | "aria-details" | "aria-disabled" | "aria-dropeffect" | "aria-errormessage" | "aria-expanded" | "aria-flowto" | "aria-grabbed" | "aria-haspopup" | "aria-hidden" | "aria-invalid" | "aria-keyshortcuts" | "aria-label" | "aria-labelledby" | "aria-level" | "aria-live" | "aria-modal" | "aria-multiline" | "aria-multiselectable" | "aria-orientation" | "aria-owns" | "aria-placeholder" | "aria-posinset" | "aria-pressed" | "aria-readonly" | "aria-relevant" | "aria-required" | "aria-roledescription" | "aria-rowcount" | "aria-rowindex" | "aria-rowspan" | "aria-selected" | "aria-setsize" | "aria-sort" | "aria-valuemax" | "aria-valuemin" | "aria-valuenow" | "aria-valuetext" | "role" | "onContextMenu" | "onMouseUp" | "name" | "onOpenChange" | "picker" | "defaultPickerValue" | "disabledDate" | "dateRender" | "monthCellRender" | "renderExtraFooter" | "onPanelChange" | "onOk" | "showToday" | "showTime" | "disabledTime" | "format" | "popupStyle" | "inputReadOnly" | "pickerRef"> & {
        locale?: {
            lang: {
                locale: string;
                monthBeforeYear?: boolean | undefined;
                yearFormat: string;
                monthFormat?: string | undefined;
                today: string;
                now: string;
                backToToday: string;
                ok: string;
                timeSelect: string;
                dateSelect: string;
                weekSelect?: string | undefined;
                clear: string;
                month: string;
                year: string;
                previousMonth: string;
                nextMonth: string;
                monthSelect: string;
                yearSelect: string;
                decadeSelect: string;
                dayFormat: string;
                dateFormat: string;
                dateTimeFormat: string;
                previousYear: string;
                nextYear: string;
                previousDecade: string;
                nextDecade: string;
                previousCentury: string;
                nextCentury: string;
                shortWeekDays?: string[] | undefined;
                shortMonths?: string[] | undefined;
                placeholder: string;
                yearPlaceholder: string;
                monthPlaceholder: string;
                weekPlaceholder: string;
                rangePlaceholder: string[];
                rangeYearPlaceholder: string[];
                rangeMonthPlaceholder: string[];
                rangeWeekPlaceholder: string[];
            };
            timePickerLocale: {
                placeholder: string;
                rangePlaceholder: string[];
            };
        } | undefined;
        size?: import("../button").ButtonSize;
        bordered?: boolean | undefined;
    }, "value" | "style" | "direction" | "className" | "prefixCls" | "locale" | "size" | "getPopupContainer" | "onChange" | "disabled" | "onClick" | "open" | "suffixIcon" | "clearIcon" | "mode" | "defaultValue" | "allowClear" | "defaultOpen" | "dropdownClassName" | "dropdownAlign" | "transitionName" | "autoFocus" | "placeholder" | "tabIndex" | "onSelect" | "onBlur" | "onFocus" | "onMouseDown" | "onMouseEnter" | "onMouseLeave" | "aria-activedescendant" | "aria-atomic" | "aria-autocomplete" | "aria-busy" | "aria-checked" | "aria-colcount" | "aria-colindex" | "aria-colspan" | "aria-controls" | "aria-current" | "aria-describedby" | "aria-details" | "aria-disabled" | "aria-dropeffect" | "aria-errormessage" | "aria-expanded" | "aria-flowto" | "aria-grabbed" | "aria-haspopup" | "aria-hidden" | "aria-invalid" | "aria-keyshortcuts" | "aria-label" | "aria-labelledby" | "aria-level" | "aria-live" | "aria-modal" | "aria-multiline" | "aria-multiselectable" | "aria-orientation" | "aria-owns" | "aria-placeholder" | "aria-posinset" | "aria-pressed" | "aria-readonly" | "aria-relevant" | "aria-required" | "aria-roledescription" | "aria-rowcount" | "aria-rowindex" | "aria-rowspan" | "aria-selected" | "aria-setsize" | "aria-sort" | "aria-valuemax" | "aria-valuemin" | "aria-valuenow" | "aria-valuetext" | "bordered" | "role" | "onContextMenu" | "onMouseUp" | "name" | "onOpenChange" | "defaultPickerValue" | "disabledDate" | "dateRender" | "monthCellRender" | "renderExtraFooter" | "onPanelChange" | "onOk" | "showToday" | "showTime" | "disabledTime" | "format" | "popupStyle" | "inputReadOnly" | "pickerRef">, any>;
    MonthPicker: import("react").ComponentClass<Pick<Pick<import("rc-picker/lib/Picker").PickerDateProps<Moment>, "value" | "style" | "direction" | "className" | "prefixCls" | "getPopupContainer" | "onChange" | "disabled" | "onClick" | "open" | "suffixIcon" | "clearIcon" | "mode" | "defaultValue" | "allowClear" | "defaultOpen" | "dropdownClassName" | "dropdownAlign" | "transitionName" | "autoFocus" | "placeholder" | "tabIndex" | "onSelect" | "onBlur" | "onFocus" | "onMouseDown" | "onMouseEnter" | "onMouseLeave" | "aria-activedescendant" | "aria-atomic" | "aria-autocomplete" | "aria-busy" | "aria-checked" | "aria-colcount" | "aria-colindex" | "aria-colspan" | "aria-controls" | "aria-current" | "aria-describedby" | "aria-details" | "aria-disabled" | "aria-dropeffect" | "aria-errormessage" | "aria-expanded" | "aria-flowto" | "aria-grabbed" | "aria-haspopup" | "aria-hidden" | "aria-invalid" | "aria-keyshortcuts" | "aria-label" | "aria-labelledby" | "aria-level" | "aria-live" | "aria-modal" | "aria-multiline" | "aria-multiselectable" | "aria-orientation" | "aria-owns" | "aria-placeholder" | "aria-posinset" | "aria-pressed" | "aria-readonly" | "aria-relevant" | "aria-required" | "aria-roledescription" | "aria-rowcount" | "aria-rowindex" | "aria-rowspan" | "aria-selected" | "aria-setsize" | "aria-sort" | "aria-valuemax" | "aria-valuemin" | "aria-valuenow" | "aria-valuetext" | "role" | "onContextMenu" | "onMouseUp" | "name" | "onOpenChange" | "picker" | "defaultPickerValue" | "disabledDate" | "dateRender" | "monthCellRender" | "renderExtraFooter" | "onPanelChange" | "onOk" | "showToday" | "showTime" | "disabledTime" | "format" | "popupStyle" | "inputReadOnly" | "pickerRef"> & {
        locale?: {
            lang: {
                locale: string;
                monthBeforeYear?: boolean | undefined;
                yearFormat: string;
                monthFormat?: string | undefined;
                today: string;
                now: string;
                backToToday: string;
                ok: string;
                timeSelect: string;
                dateSelect: string;
                weekSelect?: string | undefined;
                clear: string;
                month: string;
                year: string;
                previousMonth: string;
                nextMonth: string;
                monthSelect: string;
                yearSelect: string;
                decadeSelect: string;
                dayFormat: string;
                dateFormat: string;
                dateTimeFormat: string;
                previousYear: string;
                nextYear: string;
                previousDecade: string;
                nextDecade: string;
                previousCentury: string;
                nextCentury: string;
                shortWeekDays?: string[] | undefined;
                shortMonths?: string[] | undefined;
                placeholder: string;
                yearPlaceholder: string;
                monthPlaceholder: string;
                weekPlaceholder: string;
                rangePlaceholder: string[];
                rangeYearPlaceholder: string[];
                rangeMonthPlaceholder: string[];
                rangeWeekPlaceholder: string[];
            };
            timePickerLocale: {
                placeholder: string;
                rangePlaceholder: string[];
            };
        } | undefined;
        size?: import("../button").ButtonSize;
        bordered?: boolean | undefined;
    }, "value" | "style" | "direction" | "className" | "prefixCls" | "locale" | "size" | "getPopupContainer" | "onChange" | "disabled" | "onClick" | "open" | "suffixIcon" | "clearIcon" | "mode" | "defaultValue" | "allowClear" | "defaultOpen" | "dropdownClassName" | "dropdownAlign" | "transitionName" | "autoFocus" | "placeholder" | "tabIndex" | "onSelect" | "onBlur" | "onFocus" | "onMouseDown" | "onMouseEnter" | "onMouseLeave" | "aria-activedescendant" | "aria-atomic" | "aria-autocomplete" | "aria-busy" | "aria-checked" | "aria-colcount" | "aria-colindex" | "aria-colspan" | "aria-controls" | "aria-current" | "aria-describedby" | "aria-details" | "aria-disabled" | "aria-dropeffect" | "aria-errormessage" | "aria-expanded" | "aria-flowto" | "aria-grabbed" | "aria-haspopup" | "aria-hidden" | "aria-invalid" | "aria-keyshortcuts" | "aria-label" | "aria-labelledby" | "aria-level" | "aria-live" | "aria-modal" | "aria-multiline" | "aria-multiselectable" | "aria-orientation" | "aria-owns" | "aria-placeholder" | "aria-posinset" | "aria-pressed" | "aria-readonly" | "aria-relevant" | "aria-required" | "aria-roledescription" | "aria-rowcount" | "aria-rowindex" | "aria-rowspan" | "aria-selected" | "aria-setsize" | "aria-sort" | "aria-valuemax" | "aria-valuemin" | "aria-valuenow" | "aria-valuetext" | "bordered" | "role" | "onContextMenu" | "onMouseUp" | "name" | "onOpenChange" | "defaultPickerValue" | "disabledDate" | "dateRender" | "monthCellRender" | "renderExtraFooter" | "onPanelChange" | "onOk" | "showToday" | "showTime" | "disabledTime" | "format" | "popupStyle" | "inputReadOnly" | "pickerRef">, any>;
    YearPicker: import("react").ComponentClass<Pick<Pick<import("rc-picker/lib/Picker").PickerDateProps<Moment>, "value" | "style" | "direction" | "className" | "prefixCls" | "getPopupContainer" | "onChange" | "disabled" | "onClick" | "open" | "suffixIcon" | "clearIcon" | "mode" | "defaultValue" | "allowClear" | "defaultOpen" | "dropdownClassName" | "dropdownAlign" | "transitionName" | "autoFocus" | "placeholder" | "tabIndex" | "onSelect" | "onBlur" | "onFocus" | "onMouseDown" | "onMouseEnter" | "onMouseLeave" | "aria-activedescendant" | "aria-atomic" | "aria-autocomplete" | "aria-busy" | "aria-checked" | "aria-colcount" | "aria-colindex" | "aria-colspan" | "aria-controls" | "aria-current" | "aria-describedby" | "aria-details" | "aria-disabled" | "aria-dropeffect" | "aria-errormessage" | "aria-expanded" | "aria-flowto" | "aria-grabbed" | "aria-haspopup" | "aria-hidden" | "aria-invalid" | "aria-keyshortcuts" | "aria-label" | "aria-labelledby" | "aria-level" | "aria-live" | "aria-modal" | "aria-multiline" | "aria-multiselectable" | "aria-orientation" | "aria-owns" | "aria-placeholder" | "aria-posinset" | "aria-pressed" | "aria-readonly" | "aria-relevant" | "aria-required" | "aria-roledescription" | "aria-rowcount" | "aria-rowindex" | "aria-rowspan" | "aria-selected" | "aria-setsize" | "aria-sort" | "aria-valuemax" | "aria-valuemin" | "aria-valuenow" | "aria-valuetext" | "role" | "onContextMenu" | "onMouseUp" | "name" | "onOpenChange" | "picker" | "defaultPickerValue" | "disabledDate" | "dateRender" | "monthCellRender" | "renderExtraFooter" | "onPanelChange" | "onOk" | "showToday" | "showTime" | "disabledTime" | "format" | "popupStyle" | "inputReadOnly" | "pickerRef"> & {
        locale?: {
            lang: {
                locale: string;
                monthBeforeYear?: boolean | undefined;
                yearFormat: string;
                monthFormat?: string | undefined;
                today: string;
                now: string;
                backToToday: string;
                ok: string;
                timeSelect: string;
                dateSelect: string;
                weekSelect?: string | undefined;
                clear: string;
                month: string;
                year: string;
                previousMonth: string;
                nextMonth: string;
                monthSelect: string;
                yearSelect: string;
                decadeSelect: string;
                dayFormat: string;
                dateFormat: string;
                dateTimeFormat: string;
                previousYear: string;
                nextYear: string;
                previousDecade: string;
                nextDecade: string;
                previousCentury: string;
                nextCentury: string;
                shortWeekDays?: string[] | undefined;
                shortMonths?: string[] | undefined;
                placeholder: string;
                yearPlaceholder: string;
                monthPlaceholder: string;
                weekPlaceholder: string;
                rangePlaceholder: string[];
                rangeYearPlaceholder: string[];
                rangeMonthPlaceholder: string[];
                rangeWeekPlaceholder: string[];
            };
            timePickerLocale: {
                placeholder: string;
                rangePlaceholder: string[];
            };
        } | undefined;
        size?: import("../button").ButtonSize;
        bordered?: boolean | undefined;
    }, "value" | "style" | "direction" | "className" | "prefixCls" | "locale" | "size" | "getPopupContainer" | "onChange" | "disabled" | "onClick" | "open" | "suffixIcon" | "clearIcon" | "mode" | "defaultValue" | "allowClear" | "defaultOpen" | "dropdownClassName" | "dropdownAlign" | "transitionName" | "autoFocus" | "placeholder" | "tabIndex" | "onSelect" | "onBlur" | "onFocus" | "onMouseDown" | "onMouseEnter" | "onMouseLeave" | "aria-activedescendant" | "aria-atomic" | "aria-autocomplete" | "aria-busy" | "aria-checked" | "aria-colcount" | "aria-colindex" | "aria-colspan" | "aria-controls" | "aria-current" | "aria-describedby" | "aria-details" | "aria-disabled" | "aria-dropeffect" | "aria-errormessage" | "aria-expanded" | "aria-flowto" | "aria-grabbed" | "aria-haspopup" | "aria-hidden" | "aria-invalid" | "aria-keyshortcuts" | "aria-label" | "aria-labelledby" | "aria-level" | "aria-live" | "aria-modal" | "aria-multiline" | "aria-multiselectable" | "aria-orientation" | "aria-owns" | "aria-placeholder" | "aria-posinset" | "aria-pressed" | "aria-readonly" | "aria-relevant" | "aria-required" | "aria-roledescription" | "aria-rowcount" | "aria-rowindex" | "aria-rowspan" | "aria-selected" | "aria-setsize" | "aria-sort" | "aria-valuemax" | "aria-valuemin" | "aria-valuenow" | "aria-valuetext" | "bordered" | "role" | "onContextMenu" | "onMouseUp" | "name" | "onOpenChange" | "defaultPickerValue" | "disabledDate" | "dateRender" | "monthCellRender" | "renderExtraFooter" | "onPanelChange" | "onOk" | "showToday" | "showTime" | "disabledTime" | "format" | "popupStyle" | "inputReadOnly" | "pickerRef">, any>;
    RangePicker: import("react").ComponentClass<BaseRangePickerProps<Moment>, any>;
    TimePicker: import("react").ComponentClass<Pick<Pick<import("rc-picker/lib/Picker").PickerTimeProps<Moment>, "value" | "style" | "direction" | "className" | "prefixCls" | "getPopupContainer" | "onChange" | "disabled" | "onClick" | "open" | "suffixIcon" | "clearIcon" | "mode" | "defaultValue" | "allowClear" | "defaultOpen" | "dropdownClassName" | "dropdownAlign" | "transitionName" | "autoFocus" | "placeholder" | "tabIndex" | "onSelect" | "onBlur" | "onFocus" | "onMouseDown" | "onMouseEnter" | "onMouseLeave" | "aria-activedescendant" | "aria-atomic" | "aria-autocomplete" | "aria-busy" | "aria-checked" | "aria-colcount" | "aria-colindex" | "aria-colspan" | "aria-controls" | "aria-current" | "aria-describedby" | "aria-details" | "aria-disabled" | "aria-dropeffect" | "aria-errormessage" | "aria-expanded" | "aria-flowto" | "aria-grabbed" | "aria-haspopup" | "aria-hidden" | "aria-invalid" | "aria-keyshortcuts" | "aria-label" | "aria-labelledby" | "aria-level" | "aria-live" | "aria-modal" | "aria-multiline" | "aria-multiselectable" | "aria-orientation" | "aria-owns" | "aria-placeholder" | "aria-posinset" | "aria-pressed" | "aria-readonly" | "aria-relevant" | "aria-required" | "aria-roledescription" | "aria-rowcount" | "aria-rowindex" | "aria-rowspan" | "aria-selected" | "aria-setsize" | "aria-sort" | "aria-valuemax" | "aria-valuemin" | "aria-valuenow" | "aria-valuetext" | "role" | "onContextMenu" | "onMouseUp" | "name" | "onOpenChange" | "picker" | "defaultPickerValue" | "disabledDate" | "dateRender" | "monthCellRender" | "renderExtraFooter" | "onPanelChange" | "onOk" | "format" | "showHour" | "showMinute" | "showSecond" | "use12Hours" | "hourStep" | "minuteStep" | "secondStep" | "hideDisabledOptions" | "disabledHours" | "disabledMinutes" | "disabledSeconds" | "popupStyle" | "inputReadOnly" | "pickerRef" | "defaultOpenValue"> & {
        locale?: {
            lang: {
                locale: string;
                monthBeforeYear?: boolean | undefined;
                yearFormat: string;
                monthFormat?: string | undefined;
                today: string;
                now: string;
                backToToday: string;
                ok: string;
                timeSelect: string;
                dateSelect: string;
                weekSelect?: string | undefined;
                clear: string;
                month: string;
                year: string;
                previousMonth: string;
                nextMonth: string;
                monthSelect: string;
                yearSelect: string;
                decadeSelect: string;
                dayFormat: string;
                dateFormat: string;
                dateTimeFormat: string;
                previousYear: string;
                nextYear: string;
                previousDecade: string;
                nextDecade: string;
                previousCentury: string;
                nextCentury: string;
                shortWeekDays?: string[] | undefined;
                shortMonths?: string[] | undefined;
                placeholder: string;
                yearPlaceholder: string;
                monthPlaceholder: string;
                weekPlaceholder: string;
                rangePlaceholder: string[];
                rangeYearPlaceholder: string[];
                rangeMonthPlaceholder: string[];
                rangeWeekPlaceholder: string[];
            };
            timePickerLocale: {
                placeholder: string;
                rangePlaceholder: string[];
            };
        } | undefined;
        size?: import("../button").ButtonSize;
        bordered?: boolean | undefined;
    }, "value" | "style" | "direction" | "className" | "prefixCls" | "locale" | "size" | "getPopupContainer" | "onChange" | "disabled" | "onClick" | "open" | "suffixIcon" | "clearIcon" | "mode" | "defaultValue" | "allowClear" | "defaultOpen" | "dropdownClassName" | "dropdownAlign" | "transitionName" | "autoFocus" | "placeholder" | "tabIndex" | "onSelect" | "onBlur" | "onFocus" | "onMouseDown" | "onMouseEnter" | "onMouseLeave" | "aria-activedescendant" | "aria-atomic" | "aria-autocomplete" | "aria-busy" | "aria-checked" | "aria-colcount" | "aria-colindex" | "aria-colspan" | "aria-controls" | "aria-current" | "aria-describedby" | "aria-details" | "aria-disabled" | "aria-dropeffect" | "aria-errormessage" | "aria-expanded" | "aria-flowto" | "aria-grabbed" | "aria-haspopup" | "aria-hidden" | "aria-invalid" | "aria-keyshortcuts" | "aria-label" | "aria-labelledby" | "aria-level" | "aria-live" | "aria-modal" | "aria-multiline" | "aria-multiselectable" | "aria-orientation" | "aria-owns" | "aria-placeholder" | "aria-posinset" | "aria-pressed" | "aria-readonly" | "aria-relevant" | "aria-required" | "aria-roledescription" | "aria-rowcount" | "aria-rowindex" | "aria-rowspan" | "aria-selected" | "aria-setsize" | "aria-sort" | "aria-valuemax" | "aria-valuemin" | "aria-valuenow" | "aria-valuetext" | "bordered" | "role" | "onContextMenu" | "onMouseUp" | "name" | "onOpenChange" | "defaultPickerValue" | "disabledDate" | "dateRender" | "monthCellRender" | "renderExtraFooter" | "onPanelChange" | "onOk" | "format" | "showHour" | "showMinute" | "showSecond" | "use12Hours" | "hourStep" | "minuteStep" | "secondStep" | "hideDisabledOptions" | "disabledHours" | "disabledMinutes" | "disabledSeconds" | "popupStyle" | "inputReadOnly" | "pickerRef" | "defaultOpenValue">, any>;
};
export default DatePicker;
